/*
 * Interface wrapper code.
 *
 * Generated by SIP 4.19.12
 */

#include "sipAPIthreed.h"

#line 199 "veusz/helpers/src/threed/threed.sip"
#include <mmaths.h>
#line 12 "build/temp.linux-aarch64-3.7/sipthreedMat3.cpp"

#line 78 "veusz/helpers/src/threed/threed.sip"
#include <mmaths.h>
#line 16 "build/temp.linux-aarch64-3.7/sipthreedMat3.cpp"


extern "C" {static PyObject *meth_Mat3_set(PyObject *, PyObject *);}
static PyObject *meth_Mat3_set(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        uint a0;
        uint a1;
        double a2;
         ::Mat3 *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Buud", &sipSelf, sipType_Mat3, &sipCpp, &a0, &a1, &a2))
        {
            int sipIsErr = 0;

#line 205 "veusz/helpers/src/threed/threed.sip"
    if(a0 > 2 || a1 > 2)
      {
	sipIsErr = 1;
	PyErr_SetString(PyExc_ValueError, "Index should be 0<=i<=2");
      }
    else
      sipCpp->operator()(a0, a1) = a2;
#line 42 "build/temp.linux-aarch64-3.7/sipthreedMat3.cpp"

            if (sipIsErr)
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Mat3, sipName_set, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Mat3_get(PyObject *, PyObject *);}
static PyObject *meth_Mat3_get(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        uint a0;
        uint a1;
        const  ::Mat3 *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Buu", &sipSelf, sipType_Mat3, &sipCpp, &a0, &a1))
        {
            double sipRes = 0;
            int sipIsErr = 0;

#line 215 "veusz/helpers/src/threed/threed.sip"
    if(a0 > 2 || a1 > 2)
      {
	sipIsErr = 1;
	PyErr_SetString(PyExc_ValueError, "Index should be 0<=i<=2");
      }
    else
      sipRes = sipCpp->operator()(a0, a1);
#line 82 "build/temp.linux-aarch64-3.7/sipthreedMat3.cpp"

            if (sipIsErr)
                return 0;

            return PyFloat_FromDouble(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Mat3, sipName_get, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Mat3_transpose(PyObject *, PyObject *);}
static PyObject *meth_Mat3_transpose(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        const  ::Mat3 *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_Mat3, &sipCpp))
        {
             ::Mat3*sipRes;

            sipRes = new  ::Mat3(sipCpp->transpose());

            return sipConvertFromNewType(sipRes,sipType_Mat3,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Mat3, sipName_transpose, NULL);

    return NULL;
}


extern "C" {static PyObject *slot_Mat3___mul__(PyObject *,PyObject *);}
static PyObject *slot_Mat3___mul__(PyObject *sipArg0,PyObject *sipArg1)
{
    PyObject *sipParseErr = NULL;

    {
         ::Mat3* a0;
        const  ::Mat3* a1;

        if (sipParsePair(&sipParseErr, sipArg0, sipArg1, "J9J9", sipType_Mat3, &a0, sipType_Mat3, &a1))
        {
             ::Mat3*sipRes;

            sipRes = new  ::Mat3((*a0 * *a1));

            return sipConvertFromNewType(sipRes,sipType_Mat3,NULL);
        }
    }

    {
         ::Mat3* a0;
        const  ::Vec3* a1;

        if (sipParsePair(&sipParseErr, sipArg0, sipArg1, "J9J9", sipType_Mat3, &a0, sipType_Vec3, &a1))
        {
             ::Vec3*sipRes;

            sipRes = new  ::Vec3((*a0 * *a1));

            return sipConvertFromNewType(sipRes,sipType_Vec3,NULL);
        }
    }

    Py_XDECREF(sipParseErr);

    if (sipParseErr == Py_None)
        return NULL;

    return sipPySlotExtend(&sipModuleAPI_threed, mul_slot, NULL, sipArg0, sipArg1);
}


/* Call the instance's destructor. */
extern "C" {static void release_Mat3(void *, int);}
static void release_Mat3(void *sipCppV, int)
{
    delete reinterpret_cast< ::Mat3 *>(sipCppV);
}


extern "C" {static void assign_Mat3(void *, SIP_SSIZE_T, void *);}
static void assign_Mat3(void *sipDst, SIP_SSIZE_T sipDstIdx, void *sipSrc)
{
    reinterpret_cast< ::Mat3 *>(sipDst)[sipDstIdx] = *reinterpret_cast< ::Mat3 *>(sipSrc);
}


extern "C" {static void *array_Mat3(SIP_SSIZE_T);}
static void *array_Mat3(SIP_SSIZE_T sipNrElem)
{
    return new  ::Mat3[sipNrElem];
}


extern "C" {static void *copy_Mat3(const void *, SIP_SSIZE_T);}
static void *copy_Mat3(const void *sipSrc, SIP_SSIZE_T sipSrcIdx)
{
    return new  ::Mat3(reinterpret_cast<const  ::Mat3 *>(sipSrc)[sipSrcIdx]);
}


extern "C" {static void dealloc_Mat3(sipSimpleWrapper *);}
static void dealloc_Mat3(sipSimpleWrapper *sipSelf)
{
    if (sipIsOwnedByPython(sipSelf))
    {
        release_Mat3(sipGetAddress(sipSelf), 0);
    }
}


extern "C" {static void *init_type_Mat3(sipSimpleWrapper *, PyObject *, PyObject *, PyObject **, PyObject **, PyObject **);}
static void *init_type_Mat3(sipSimpleWrapper *, PyObject *sipArgs, PyObject *sipKwds, PyObject **sipUnused, PyObject **, PyObject **sipParseErr)
{
     ::Mat3 *sipCpp = 0;

    {
        if (sipParseKwdArgs(sipParseErr, sipArgs, sipKwds, NULL, sipUnused, ""))
        {
            sipCpp = new  ::Mat3();

            return sipCpp;
        }
    }

    {
        const  ::Mat3* a0;

        if (sipParseKwdArgs(sipParseErr, sipArgs, sipKwds, NULL, sipUnused, "J9", sipType_Mat3, &a0))
        {
            sipCpp = new  ::Mat3(*a0);

            return sipCpp;
        }
    }

    return NULL;
}


/* Define this type's Python slots. */
static sipPySlotDef slots_Mat3[] = {
    {(void *)slot_Mat3___mul__, mul_slot},
    {0, (sipPySlotType)0}
};


static PyMethodDef methods_Mat3[] = {
    {SIP_MLNAME_CAST(sipName_get), meth_Mat3_get, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_set), meth_Mat3_set, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_transpose), meth_Mat3_transpose, METH_VARARGS, NULL}
};


static pyqt5ClassPluginDef plugin_Mat3 = {
    0,
    0,
    0,
    0
};


sipClassTypeDef sipTypeDef_threed_Mat3 = {
    {
        -1,
        0,
        0,
        SIP_TYPE_SUPER_INIT|SIP_TYPE_CLASS,
        sipNameNr_Mat3,
        {0},
        &plugin_Mat3
    },
    {
        sipNameNr_Mat3,
        {0, 0, 1},
        3, methods_Mat3,
        0, 0,
        0, 0,
        {0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    },
    0,
    -1,
    -1,
    0,
    slots_Mat3,
    init_type_Mat3,
    0,
    0,
#if PY_MAJOR_VERSION >= 3
    0,
    0,
#else
    0,
    0,
    0,
    0,
#endif
    dealloc_Mat3,
    assign_Mat3,
    array_Mat3,
    copy_Mat3,
    release_Mat3,
    0,
    0,
    0,
    0,
    0,
    0,
    0
};
