/*
 * Interface wrapper code.
 *
 * Generated by SIP 4.19.12
 */

#include "sipAPIthreed.h"

#line 160 "veusz/helpers/src/threed/threed.sip"
#include <mmaths.h>
#line 12 "build/temp.linux-aarch64-3.7/sipthreedMat4.cpp"

#line 37 "veusz/helpers/src/threed/threed.sip"
#include <mmaths.h>
#line 16 "build/temp.linux-aarch64-3.7/sipthreedMat4.cpp"


extern "C" {static PyObject *meth_Mat4_set(PyObject *, PyObject *);}
static PyObject *meth_Mat4_set(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        uint a0;
        uint a1;
        double a2;
         ::Mat4 *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Buud", &sipSelf, sipType_Mat4, &sipCpp, &a0, &a1, &a2))
        {
            int sipIsErr = 0;

#line 166 "veusz/helpers/src/threed/threed.sip"
    if(a0 > 3 || a1 > 3)
      {
	sipIsErr = 1;
	PyErr_SetString(PyExc_ValueError, "Index should be 0<=i<=3");
      }
    else
      sipCpp->operator()(a0, a1) = a2;
#line 42 "build/temp.linux-aarch64-3.7/sipthreedMat4.cpp"

            if (sipIsErr)
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Mat4, sipName_set, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Mat4_get(PyObject *, PyObject *);}
static PyObject *meth_Mat4_get(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        uint a0;
        uint a1;
        const  ::Mat4 *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Buu", &sipSelf, sipType_Mat4, &sipCpp, &a0, &a1))
        {
            double sipRes = 0;
            int sipIsErr = 0;

#line 176 "veusz/helpers/src/threed/threed.sip"
    if(a0 > 3 || a1 > 3)
      {
	sipIsErr = 1;
	PyErr_SetString(PyExc_ValueError, "Index should be 0<=i<=3");
      }
    else
      sipRes = sipCpp->operator()(a0, a1);
#line 82 "build/temp.linux-aarch64-3.7/sipthreedMat4.cpp"

            if (sipIsErr)
                return 0;

            return PyFloat_FromDouble(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Mat4, sipName_get, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Mat4_transpose(PyObject *, PyObject *);}
static PyObject *meth_Mat4_transpose(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        const  ::Mat4 *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_Mat4, &sipCpp))
        {
             ::Mat4*sipRes;

            sipRes = new  ::Mat4(sipCpp->transpose());

            return sipConvertFromNewType(sipRes,sipType_Mat4,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Mat4, sipName_transpose, NULL);

    return NULL;
}


extern "C" {static PyObject *slot_Mat4___mul__(PyObject *,PyObject *);}
static PyObject *slot_Mat4___mul__(PyObject *sipArg0,PyObject *sipArg1)
{
    PyObject *sipParseErr = NULL;

    {
         ::Mat4* a0;
        const  ::Mat4* a1;

        if (sipParsePair(&sipParseErr, sipArg0, sipArg1, "J9J9", sipType_Mat4, &a0, sipType_Mat4, &a1))
        {
             ::Mat4*sipRes;

            sipRes = new  ::Mat4((*a0 * *a1));

            return sipConvertFromNewType(sipRes,sipType_Mat4,NULL);
        }
    }

    {
         ::Mat4* a0;
        const  ::Vec4* a1;

        if (sipParsePair(&sipParseErr, sipArg0, sipArg1, "J9J9", sipType_Mat4, &a0, sipType_Vec4, &a1))
        {
             ::Vec4*sipRes;

            sipRes = new  ::Vec4((*a0 * *a1));

            return sipConvertFromNewType(sipRes,sipType_Vec4,NULL);
        }
    }

    Py_XDECREF(sipParseErr);

    if (sipParseErr == Py_None)
        return NULL;

    return sipPySlotExtend(&sipModuleAPI_threed, mul_slot, NULL, sipArg0, sipArg1);
}


/* Call the instance's destructor. */
extern "C" {static void release_Mat4(void *, int);}
static void release_Mat4(void *sipCppV, int)
{
    delete reinterpret_cast< ::Mat4 *>(sipCppV);
}


extern "C" {static void assign_Mat4(void *, SIP_SSIZE_T, void *);}
static void assign_Mat4(void *sipDst, SIP_SSIZE_T sipDstIdx, void *sipSrc)
{
    reinterpret_cast< ::Mat4 *>(sipDst)[sipDstIdx] = *reinterpret_cast< ::Mat4 *>(sipSrc);
}


extern "C" {static void *array_Mat4(SIP_SSIZE_T);}
static void *array_Mat4(SIP_SSIZE_T sipNrElem)
{
    return new  ::Mat4[sipNrElem];
}


extern "C" {static void *copy_Mat4(const void *, SIP_SSIZE_T);}
static void *copy_Mat4(const void *sipSrc, SIP_SSIZE_T sipSrcIdx)
{
    return new  ::Mat4(reinterpret_cast<const  ::Mat4 *>(sipSrc)[sipSrcIdx]);
}


extern "C" {static void dealloc_Mat4(sipSimpleWrapper *);}
static void dealloc_Mat4(sipSimpleWrapper *sipSelf)
{
    if (sipIsOwnedByPython(sipSelf))
    {
        release_Mat4(sipGetAddress(sipSelf), 0);
    }
}


extern "C" {static void *init_type_Mat4(sipSimpleWrapper *, PyObject *, PyObject *, PyObject **, PyObject **, PyObject **);}
static void *init_type_Mat4(sipSimpleWrapper *, PyObject *sipArgs, PyObject *sipKwds, PyObject **sipUnused, PyObject **, PyObject **sipParseErr)
{
     ::Mat4 *sipCpp = 0;

    {
        if (sipParseKwdArgs(sipParseErr, sipArgs, sipKwds, NULL, sipUnused, ""))
        {
            sipCpp = new  ::Mat4();

            return sipCpp;
        }
    }

    {
        const  ::Mat4* a0;

        if (sipParseKwdArgs(sipParseErr, sipArgs, sipKwds, NULL, sipUnused, "J9", sipType_Mat4, &a0))
        {
            sipCpp = new  ::Mat4(*a0);

            return sipCpp;
        }
    }

    return NULL;
}


/* Define this type's Python slots. */
static sipPySlotDef slots_Mat4[] = {
    {(void *)slot_Mat4___mul__, mul_slot},
    {0, (sipPySlotType)0}
};


static PyMethodDef methods_Mat4[] = {
    {SIP_MLNAME_CAST(sipName_get), meth_Mat4_get, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_set), meth_Mat4_set, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_transpose), meth_Mat4_transpose, METH_VARARGS, NULL}
};


static pyqt5ClassPluginDef plugin_Mat4 = {
    0,
    0,
    0,
    0
};


sipClassTypeDef sipTypeDef_threed_Mat4 = {
    {
        -1,
        0,
        0,
        SIP_TYPE_SUPER_INIT|SIP_TYPE_CLASS,
        sipNameNr_Mat4,
        {0},
        &plugin_Mat4
    },
    {
        sipNameNr_Mat4,
        {0, 0, 1},
        3, methods_Mat4,
        0, 0,
        0, 0,
        {0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    },
    0,
    -1,
    -1,
    0,
    slots_Mat4,
    init_type_Mat4,
    0,
    0,
#if PY_MAJOR_VERSION >= 3
    0,
    0,
#else
    0,
    0,
    0,
    0,
#endif
    dealloc_Mat4,
    assign_Mat4,
    array_Mat4,
    copy_Mat4,
    release_Mat4,
    0,
    0,
    0,
    0,
    0,
    0,
    0
};
